Bug 657849 - Serbian glyphs for Wikipedia
Serbian glyphs for Wikipedia
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: liberation-fonts (Show other bugs)
19
Unspecified Unspecified
low Severity medium
: ---
: ---
Assigned To: Pravin Satpute
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-11-28 08:03 EST by Alessandro Ceschini
Modified: 2013-08-25 18:57 EDT (History)
7 users (show)

See Also:
Fixed In Version: liberation-fonts-1.07.3-1.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-08-25 18:57:11 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Russian versus Serbian glyphs (24.63 KB, application/pdf)
2010-11-29 08:46 EST, Alessandro Ceschini
no flags Details
Russian vs. Serbian Glyphs (corrected) (25.07 KB, application/pdf)
2010-11-29 17:12 EST, Alessandro Ceschini
no flags Details
added locl feature for serbian and added glyph variant for U+043F (130.57 KB, application/octet-stream)
2011-10-12 06:54 EDT, Pravin Satpute
no flags Details
liberation fonts with serbian glyph variant for п б г д п т (131.18 KB, application/x-font-ttf)
2011-10-12 07:50 EDT, Pravin Satpute
no flags Details
Shows the differences between Serbian localized U+0431 and Greek U+03B4 (69.17 KB, application/pdf)
2011-10-13 04:32 EDT, Alessandro Ceschini
no flags Details
Russian and Serbian glyphs (10.55 KB, image/gif)
2011-10-19 07:53 EDT, Зоран В. Петровић
no flags Details
Liberation Sans Italic font GSUB table, Serbian Glyphs (190.45 KB, image/jpeg)
2011-10-20 03:45 EDT, Зоран В. Петровић
no flags Details
Liberation Sans Narrow font, No GSUB table for Serbian Gplyphs (99.78 KB, image/jpeg)
2011-10-20 03:46 EDT, Зоран В. Петровић
no flags Details
Download, link, click to Builds (144.51 KB, image/jpeg)
2011-10-20 07:07 EDT, Зоран В. Петровић
no flags Details
Liberation SANS Italic Serbian Glyphs and Ubuntu Italic Serbian Glyphs (4.80 KB, image/jpeg)
2011-10-20 08:29 EDT, Зоран В. Петровић
no flags Details
FontForge Ubuntu Light Italic font with Serbian Glyphs (429.34 KB, image/jpeg)
2011-10-20 08:35 EDT, Зоран В. Петровић
no flags Details
DejaVu Serif (correct) vs. Liberation Serif (wrong) glyphs (33.56 KB, application/pdf)
2011-10-24 08:53 EDT, Alessandro Ceschini
no flags Details
The last letter is SHA (15.74 KB, image/png)
2011-10-24 09:10 EDT, Alessandro Ceschini
no flags Details
Liberation Serif italic in Thundebird 7.0.1 under Windows 7 x64 (47.92 KB, image/jpeg)
2011-10-24 14:05 EDT, Зоран В. Петровић
no flags Details
Liberation Serif , Firefox 7.0.1 Windows 7 x64 (204.19 KB, image/jpeg)
2011-10-24 14:09 EDT, Зоран В. Петровић
no flags Details
This is how small letter te should look (104.35 KB, image/jpeg)
2011-10-24 14:12 EDT, Зоран В. Петровић
no flags Details
How Ubuntu font implemented Serbian Glyphs names (49.78 KB, image/jpeg)
2011-10-24 15:11 EDT, Зоран В. Петровић
no flags Details
This is how Liberation font implemented Serbian Glyphs names (48.40 KB, image/jpeg)
2011-10-24 15:12 EDT, Зоран В. Петровић
no flags Details
How FontForge read Ubuntu Serbian Glyphs (117.01 KB, image/jpeg)
2011-10-24 15:12 EDT, Зоран В. Петровић
no flags Details
How FontForge read Liberation Serbian Glyphs (111.00 KB, image/jpeg)
2011-10-24 15:19 EDT, Зоран В. Петровић
no flags Details
How DejaVu implemented Serbian Glyphs names (53.46 KB, image/jpeg)
2011-10-24 15:42 EDT, Зоран В. Петровић
no flags Details
Year 1998, How Adobe implemnted Serbian Cyrillic Glyphs (335.60 KB, application/pdf)
2011-10-25 02:19 EDT, Зоран В. Петровић
no flags Details
DejaVu font Serbian Glyphs Unicode value (72.91 KB, image/jpeg)
2011-10-25 02:33 EDT, Зоран В. Петровић
no flags Details
Liberation Serif Serbian Glyphs Unicode values (71.38 KB, image/jpeg)
2011-10-25 02:36 EDT, Зоран В. Петровић
no flags Details
added U+0431 in Regular like Dejavu (130.68 KB, application/octet-stream)
2011-10-25 05:30 EDT, Pravin Satpute
no flags Details
Both glyph names do work in XeLaTeX (49.90 KB, application/pdf)
2011-10-25 06:17 EDT, Alessandro Ceschini
no flags Details
Unicode FC65 position belongs to Arabic Presentation Forms A (34.45 KB, image/jpeg)
2011-10-25 06:36 EDT, Зоран В. Петровић
no flags Details
DejaVu PUA range for Serbian Glyphs (219.58 KB, image/jpeg)
2011-10-25 06:37 EDT, Зоран В. Петровић
no flags Details

  None (edit)
Description Alessandro Ceschini 2010-11-28 08:03:06 EST
Description of problem:
Hy, at the Serbian Wikipedia we are planning on supporting localized Serbian glyphs (as opposed to standard/Russian ones) on screen by taking advantage of the next generation of browser (like Firefox 4) compliant with OpenType features.
What we lack is a pool of free OpenType fonts with Serbian glyphs to be accessed through the locl feature. DejaVu is, as far as I know, the only free font which does so (although with some bugs) but, particularly the Serif version, can be described as ugly at best.
So, what about a new release of Liberation Fonts containing a locl table for Serbian?
Thank you.
Comment 1 Dave Crossland 2010-11-28 09:24:05 EST
The ChromeOS fonts may have the support you want, and look very similar to Liberation... Arimo and Tinos, http://code.google.com/p/googlefontdirectory/source/browse
Comment 2 Alessandro Ceschini 2010-11-28 10:32:29 EST
(In reply to comment #1)
> The ChromeOS fonts may have the support you want, and look very similar to
> Liberation... Arimo and Tinos,
> http://code.google.com/p/googlefontdirectory/source/browse

Thank you Dave Crossland for your interest, but those fonts don't even have support for Cyrillic script! I've just tested them all in XeLaTex.
Back to my proposal, is it possible for you to do so in the foreseeable future?
Thank you.
Comment 3 Dave Crossland 2010-11-28 11:05:22 EST
http://code.google.com/p/googlefontdirectory/source/browse/tinos/src/Tinos-Regular.ttf has Cyrillic. 

Fontaine output:

Fonts:
   Font:
      Common name: Tinos
      Native name: 
      Sub family: Regular
      Style: normal
      Weight: normal
      Fixed width: no
      Fixed sizes: no
      Copyright: Digitized data copyright (c) 2010 Google Corporation.
      License: OFL
      License url: http://scripts.sil.org/OFL
      Glyph count: 2424
      Character count: 2166
      Orthographies:
         Orthography:
            Common name: Basic Latin
            Native name: Basic Latin
            Support level: full
         
         Orthography:
            Common name: Western European
            Native name: Western European
            Support level: full
         
         Orthography:
            Common name: Euro
            Native name: Euro
            Support level: full
         
         Orthography:
            Common name: Catalan
            Native name: Català
            Support level: full
         
         Orthography:
            Common name: Baltic
            Native name: Baltic
            Support level: full
         
         Orthography:
            Common name: Turkish
            Native name: Türkçe
            Support level: full
         
         Orthography:
            Common name: Central European
            Native name: Central European
            Support level: full
         
         Orthography:
            Common name: Romanian
            Native name: Română
            Support level: full
         
         Orthography:
            Common name: Vietnamese
            Native name: tiếng Việt
            Support level: full
         
         Orthography:
            Common name: Pan African Latin
            Native name: Pan African Latin
            Support level: full
         
         Orthography:
            Common name: Dutch
            Native name: Nederlands
            Support level: full
         
         Orthography:
            Common name: Afrikaans
            Native name: Afrikaans
            Support level: full
         
         Orthography:
            Common name: Pinyin
            Native name: 汉语拼音
            Support level: full
         
         Orthography:
            Common name: IPA
            Native name: aɪ pʰiː eɪ
            Support level: full
         
         Orthography:
            Common name: Venda
            Native name: Tshivenḓa
            Support level: full
         
         Orthography:
            Common name: Igbo Onwu
            Native name: Asụsụ Igbo
            Support level: full
         
         Orthography:
            Common name: Basic Greek
            Native name: Ελληνικό αλφάβητο
            Support level: full
         
         Orthography:
            Common name: Polytonic Greek
            Native name: Polytonic Greek
            Support level: full
         
         Orthography:
            Common name: Basic Cyrillic
            Native name: Кири́ллица
            Support level: full
Comment 4 Alessandro Ceschini 2010-11-28 14:52:45 EST
OK, Dave, you're right, Tinos does support Cyrillic as per the Character Map but it doesn't work in XeLaTex which makes me think it's not an OpenType font at all. Please notice that OpenType is much more than just plain Unicode, it's about glyph variations. Fonts like say, Tinos may have Cyrillic support (including Serbian) but not the glyphs appropriate for Serbian. These can only be accessed through the OpenType locl (localization) table which provides the correct glyphs depending on language. Glyphs, not characters.
I repeat it, I might be mistaken but it seems to me Tinos is not an OpenType font at all, so it too would require a patch in order to support at least the locl tabe we need in order to correctly visualize Serbian glyphs on screen.
Comment 5 Pravin Satpute 2010-11-29 01:03:27 EST
(In reply to comment #0)
> So, what about a new release of Liberation Fonts containing a locl table for
> Serbian?
let me know how many characters we need to add to Liberation Fonts?
Also give some references for standard or available text images with you?
Comment 6 Ben Laenen 2010-11-29 07:37:11 EST
(In reply to comment #0)
> DejaVu is, as far as I know, the only free
> font which does so (although with some bugs) but, particularly the Serif
> version, can be described as ugly at best.

If there are problems with DejaVu, please report them to us as well. We cannot fix something we don't know is wrong. Our bugzilla is at https://bugs.freedesktop.org/enter_bug.cgi?product=DejaVu but you can also send something to our mailing list.
Comment 7 Alessandro Ceschini 2010-11-29 08:46:52 EST
Created attachment 463487 [details]
Russian versus Serbian glyphs
Comment 8 Alessandro Ceschini 2010-11-29 08:47:57 EST
OK, first things first. Dear Pravin Sapute, I'm sure you'll forgive my laziness: I should have provided you from the beginning with a pdf showing Russian (a.k.a. standard glyphs) versus the Serbian localized ones which I'm looking for. However, better later than never: you'll find it attached on top. Please notice that we're talking about character shape, not characters per se. You seems to have understood there's a need to implement new Serbian characters while what's lacking is actually Serbian glyphs for already existing characters. In fact, in the attached pdf you'll find the code name & number of the characters in question, with standard/Russian glyph first and the localized Serbian after. The correct implementation should not be realized by adding the glyphs I provided you in the locl table as defined by the OpenType standard.
Comment 9 Alessandro Ceschini 2010-11-29 08:52:06 EST
Now straight to second issue. Dear Ben Laenen, the connexion on the link you provided me with is not certified and therefore the browser will not me in.
Should I describe the bug here, is it the same for you?
Comment 10 Ben Laenen 2010-11-29 10:45:59 EST
(In reply to comment #9)
> Now straight to second issue. Dear Ben Laenen, the connexion on the link you
> provided me with is not certified and therefore the browser will not me in.
> Should I describe the bug here, is it the same for you?

In Firefox: I understand the risks > Add Exception, and then add the exception. It's the freedesktop bugzilla so it's completely safe. You can also write to our mailing list if you want.
Comment 11 Alessandro Ceschini 2010-11-29 16:43:55 EST
For Ben Laenen: I posted the relevant bug report here: https://bugs.freedesktop.org/show_bug.cgi?id=31979
Comment 12 Alessandro Ceschini 2010-11-29 16:50:58 EST
For Pravin Satpute: please at section 2 (Italic), line 4 read SMALL LETTER "PE" instead of SMALL LETTER "DE". Sorry for the misspelling.
Comment 13 Alessandro Ceschini 2010-11-29 17:12:12 EST
Created attachment 463595 [details]
Russian vs. Serbian Glyphs (corrected)
Comment 14 Alessandro Ceschini 2010-11-29 17:14:00 EST
In order to avoid annoying misunderstandings, the corrected version of the pdf is now online.
Comment 15 Pravin Satpute 2010-11-29 23:21:07 EST
Hi Alessandro,

  Thanks for quick information happy to see there are only 6 characters, in spare time i will surely try to add those characters and will give you once for testing.
Comment 16 Alessandro Ceschini 2010-11-30 02:23:10 EST
Dear Pravin Satpute, I appreciate your effort but I've to make my point clear: it's not characters that are needed, but rather Serbian localized glyphs for already existing characters, you can find the names & code of the relevant characters in the pdf. On the left the standard glyph, on the right the Serbian glyph I'm looking for. Most of variants occur but in italic, so how could we create two different character that differ but in the italic form?
The real solution is implementation thrugh the locl table as per the OpenType standard.
Thank you very much.
Comment 17 Pravin Satpute 2010-11-30 04:18:40 EST
yeah, recently we did this for Lohit 

see https://www.redhat.com/archives/lohit-devel-list/2010-November/msg00009.html
Comment 18 Alessandro Ceschini 2011-09-29 18:50:58 EDT
Bump!
Any news down here? It's almost a year since I opened this thread.
Comment 19 Pravin Satpute 2011-10-10 02:02:17 EDT
Hi Alessandro,

  I am looking into it, will try to update by next week. We can initially try with one character for test test and then can update same thing for other characters.
Comment 20 Alessandro Ceschini 2011-10-11 06:52:06 EDT
Hello Mr. Sapute,
I can't wait for you to post some betas here. I'll test them immediately.

Thank you very much.
Comment 21 Pravin Satpute 2011-10-12 06:11:00 EDT
like -> "HUN "  for	Hungarian

 "?"  for	Serbian

refer http://www.microsoft.com/typography/otfntdev/standot/appen.aspx
Comment 22 Alessandro Ceschini 2011-10-12 06:20:28 EDT
"SRB"

refer http://www.microsoft.com/typography/developers/opentype/languagetags.aspx
Comment 23 Pravin Satpute 2011-10-12 06:30:11 EDT
(In reply to comment #13)
> Created attachment 463595 [details]
> Russian vs. Serbian Glyphs (corrected)

U+0442 CYRILLIC SMALL LETTER TE : т Serbian Localized Glyph:

Looks like in pdf you have given wrong Unicode value for it
Comment 24 Alessandro Ceschini 2011-10-12 06:41:28 EDT
Oh, really? I just checked it and U+0442, that's the value my charmap displays. Remember the Serbian glyph diverges from the standard only in small italic, not in capital italic shape.
Comment 25 Alessandro Ceschini 2011-10-12 06:47:06 EDT
I meant the shape you see in pdf that's the small ITALIC, not the small UPRIGHT shown in the charmap. Maybe the different glyph confused you, but that's the same letter, U+0442 SMALL CYRILLIC TE, just in its italic shape.
U+0442 SMALL CYRILLIC TE UPRIGHT: Serbian glyph identical to standard glyph
U+0442 SMALL CYRILLIC TE ITALIC: Serbian glyph different
Comment 26 Pravin Satpute 2011-10-12 06:54:52 EDT
Created attachment 527671 [details]
added locl feature for serbian and added glyph variant for U+043F

1) I am not understanding what it mean by small and capital italic?
In LiberationSans We have four style:
Regular, Italic, Bold, BoldItalic

which of this is small and capital.? 

Also not understanding how shape changes in Italic and upright. kindly give me link towards some documentation so i can understand in more better way

meanwhile, i have added single letter U+043F, check that with attached font (LiberationSans-Regular)
Comment 27 Pravin Satpute 2011-10-12 07:50:20 EDT
Created attachment 527681 [details]
liberation fonts with serbian glyph variant for п б г д п т

let me is this what you expect, it will be nice if you can open LiberationSans.ttf in fontforge and let me know which shape exactly you required as a substitute for present output.
Comment 28 Alessandro Ceschini 2011-10-12 12:05:21 EDT
Ok, first things first this link shows you the difference between upright/italic Cyrillic glyphs: http://commons.wikimedia.org/wiki/File:Cyrillic-italics-nonitalics.png

Please notice these are standard/Russian glyphs not the Serbian ones. I showed the difference between Russian and Serbian glyphs in the pdf. Maybe this image is clearer to you: http://en.wikipedia.org/wiki/File:Special_Cyrillics.png As you can see from there and from my pdf, the majority of changes concerns small italic shapes ONLY, and NONE of them concerns CAPITAL be it italic or upright shapes. I hope I made my point clear.
Comment 29 Alessandro Ceschini 2011-10-12 12:19:52 EDT
As far as the font is concerned, I opened it in FontForge.
This is a an upright shape and in upright, as you can see from my pdf as well as from other images I posted above, it's only the U+0431 CYRILLIC SMALL LETTER BE that does change. The shapes you inserted for U+0433, U+0434, U+043F, U+0442 are for ITALIC not UPRIGHT shapes. In UPRIGHT standard/Russian and Serbian glyphs are identical.
Comment 30 Alessandro Ceschini 2011-10-12 12:21:53 EDT
Identical, except for U+0431, I think the pdf is quite clear.
Comment 31 Pravin Satpute 2011-10-13 03:58:39 EDT
(In reply to comment #28)
> Ok, first things first this link shows you the difference between
> upright/italic Cyrillic glyphs:
> http://commons.wikimedia.org/wiki/File:Cyrillic-italics-nonitalics.png
> 
> Please notice these are standard/Russian glyphs not the Serbian ones. I showed
> the difference between Russian and Serbian glyphs in the pdf. Maybe this image
> is clearer to you: http://en.wikipedia.org/wiki/File:Special_Cyrillics.png As
> you can see from there and from my pdf, the majority of changes concerns small
> italic shapes ONLY, and NONE of them concerns CAPITAL be it italic or upright
> shapes. I hope I made my point clear.

Yes, now very much clear.
Changes only need in Liberation Italics and BoldItalics fonts 

In Liberation Regular and Bold font change only required for U+0431.

Actually Upright word was not very clear to me.

Thanks.

Yeah shape for U+0431 is not very good, since i am not very good designer but i will try to do it. If you know any font having U+0431 shape proper as per Serbian let me know, i can take that reference and try to add it in liberation fonts.
Comment 32 Alessandro Ceschini 2011-10-13 04:30:13 EDT
Sorry, I used upright instead of regular. That's my fault. Sorry again.
As far as the shape of U+0431, I can't remember saying anything bad about its shape, I think your design is pretty good, inasmuch it's similar but not identical to GREEK DELTA U+03B4, especially because it doesn't display the descender (I don't know how you call it in typography) associated with GREEK DELTA. I also uploaded a pdf showing you a visual comparison of Serbian BE with Greek DELTA in all the fonts I know of that support Serbian locl glyphs.
I think you should also modify the kerning of U+0431 since the entries I see in FontForge are valid only for the standard shape, not for the Serbian one.
Last thing: I've been told that the Serbian shapes also apply to Macedonian, so no new glyphs, but just adding "MKD" to the substitution table.
Comment 33 Alessandro Ceschini 2011-10-13 04:32:04 EDT
Created attachment 527886 [details]
Shows the differences between Serbian localized U+0431 and Greek U+03B4
Comment 34 Fedora Update System 2011-10-14 05:52:09 EDT
liberation-fonts-1.07.1-2.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/liberation-fonts-1.07.1-2.fc16
Comment 35 Fedora Update System 2011-10-15 10:30:06 EDT
Package liberation-fonts-1.07.1-2.fc16:
* should fix your issue,
* was pushed to the Fedora 16 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing liberation-fonts-1.07.1-2.fc16'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2011-14343
then log in and leave karma (feedback).
Comment 36 Alessandro Ceschini 2011-10-15 11:25:56 EDT
How can I download it in Ubuntu? I'm using Ubuntu 11.04, not Fedora.
Comment 37 Зоран В. Петровић 2011-10-19 07:53:43 EDT
Created attachment 528987 [details]
Russian and Serbian glyphs
Comment 38 Зоран В. Петровић 2011-10-19 08:13:25 EDT
Hello.

Please can you make one small change, for Serif fonts, CYRILLIC SMALL LETTER TE.
I attached picture, you can find "correct" look for that letter.

You also have a Link for Serbian Glyphs ( example for glyphs ) at http://www.microsoft.com/typography/developers/opentype/detail.htm


IN Sans Serif italic fonts You can also modify small letters b, g, d, p, t.

If You can load with fontforge Ubuntu font font.ubuntu.com ( Sans Serif ) , You can find how they did a job about Serbian glyphs ( OpenType ), best implementation I know.
I am Serbian ( so You can trust me about Serbian glyphs )

Great job, thanks a lot.
Best Regards.
Comment 39 Fedora Update System 2011-10-20 00:03:31 EDT
liberation-fonts-1.07.1-2.fc16 has been pushed to the Fedora 16 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 40 Зоран В. Петровић 2011-10-20 02:16:43 EDT
Hello again.

When I put "IN Sans Serif italic fonts You can also modify small letters b, g, d, p, t", I mean: 
Liberation Sans Narrow Italic and Liberation Sans Narrow Italic Bold.
SANS Italic and Italic Bold are correct ( with Serbian Glyphs ), 
but SANS NARROW are without Serbian glyphs, no GPOS etc.
You are not in charge for this fonts ( SANS NARROW version) or ?

Best Regards.
Comment 41 Pravin Satpute 2011-10-20 03:27:48 EDT
Hi Зоран,

 Thanks for checking changes. 
Sorry still not understood it correctly yet.
It will be nice if you can report new bug against liberation or writ here itself.

1) step to reproduce problem
2) actual result
3) expected result

if possible do submit patch, i will surely verify it
Comment 42 Зоран В. Петровић 2011-10-20 03:45:04 EDT
Created attachment 529207 [details]
Liberation Sans Italic font GSUB table, Serbian Glyphs

Liberation Sans Italic font, GSUB table, Serbian Glyphs
Comment 43 Зоран В. Петровић 2011-10-20 03:46:27 EDT
Created attachment 529208 [details]
Liberation Sans Narrow font, No GSUB table for Serbian Gplyphs
Comment 44 Зоран В. Петровић 2011-10-20 04:16:36 EDT
Hello.

1. Liberation Sans Narrow Italic font is without Serbian Glyphs
2. Liberation Sans Narrow Italic Bold font is without Serbian Glyphs

I downloaded fonts, loaded with FontForge, attached picture show: 

NARROW versions are without Open Type features  ( GSUB ). 
Letters are without alternate glyphs ( Serbian in this case ).
In SANS NARROW no Lookup Subtable, locl ( for Serbian in this case ), no locl table at all.

In SANS NARROW You must add new lookup table, "Localized Forms in Cyrillic lookup 0" for example, I prefer  "Localized Forms in Serbian Cyrillic lookup 0", Edit Table etc. I am expecting the same amount of work You spend on font Liberation ( Italic and Italic Bold) and LiberationSans ( Italic and ItalicBold ).

Is this enough for You ?
Best Regards.
Comment 45 Pravin Satpute 2011-10-20 04:32:13 EDT
Thanks for detailed information.
Yeah, I have only added support in Sans and Serif. In next release i will do changes in Sans-Narrow and Mono fonts.
Comment 46 Alessandro Ceschini 2011-10-20 06:48:59 EDT
Sorry guys if I keep asking the same question, but where can I download the new version? In the repository https://fedorahosted.org/releases/l/i/liberation-fonts/ I can't find this new version.
Comment 47 Зоран В. Петровић 2011-10-20 07:07:02 EDT
Created attachment 529238 [details]
Download, link, click to Builds

https://admin.fedoraproject.org/updates/FEDORA-2011-14343

Then click on Builds

http://koji.fedoraproject.org/koji/buildinfo?buildID=268570
Comment 48 Pravin Satpute 2011-10-20 07:15:56 EDT
yeah, yet no commit to upstream
once it will be tested thoroughly i can push to upstream.
Comment 49 Alessandro Ceschini 2011-10-20 07:55:07 EDT
Thanks Zoran, going to test and then report.
Anyhow, only U+0431 CYRILLIC LETTER BE should be given the Serbian localized glyph, since other glyphs occur only in Italic and Sans does not NATIVELY use Italic shapes, only slanted ones.
Comment 50 Alessandro Ceschini 2011-10-20 08:02:44 EDT
Ahem, before releasing my humble suggestion is that you first set up a decent kerning for these new glyphs. I realized Liberation Serif has a fairly complicated system of kerning, I don't know how you calculated it, but you I suppose you should calculate it also for these new glyphs, particularly in the Italic/Bold Italic where there are 5 new glyphs (as opposed to Regular/Bold where there's only 1 new glyph). In short, with these new glyphs, the whole system of kerning is in need of an update.
Comment 51 Зоран В. Петровић 2011-10-20 08:29:35 EDT
Created attachment 529258 [details]
Liberation SANS Italic Serbian Glyphs and Ubuntu Italic Serbian Glyphs

Hello.

I mean SANS font like this one ( Ubuntu, attached picture , FontForge )

Ubuntu Light Italic  ( SANS type font, no serifs ), perfect, full OpenType features. Both Russian and Serbian Glyphs. 
The same look is with Microsoft compatible OpenType fonts ( both Serif and Sans ).
I do not understand what NATIVELY mean against SLANTED, but Windows and Ubuntu Linux  ( or any other Linux distribution I use, CentOS, Ubuntu, Mint, Fedora, Scientific Linux) recognize font "Liberation Sans Italic" as Italic font or Ubuntu Italic as Italic fonts.

TeX users mostly use name Slanted for "Italic". If You ( using XeTeX ) have some problem about recognizing this fonts, all application I am using are ok to me ( Italic or Slanted ).

BEST example for using Italic ( or Slanted ) is to Login to some Ubuntu machine( with Serbian localization, not English or Italian ) and Display manager, programs, Update Manager, applications, all of them work WITH ITALIC SERBIAN GLYPHS without any additional tweak.
It is not possible to achieve the same with Liberation SANS Italic ( Liberation SANS Narrow Italic ) without this b,g,d,p,t Serbian glyphs.

You can test SYSTEM font ( put this new Liberation SANS with Serbian Glyphs) under Ubuntu Linux ( with Serbian localization ) and look for difference.
Default Ubuntu font properties show font Sans ( hard coded to DejaVu font, alias Vera ), change to this new LiberationSans with Serbian Glyphs and look at effects.

All Microsoft new SANS OpenType fonts also have b,g,d,p,t Serbian Glyphs ( similar to Ubuntu font design ).

Best Regards.
Comment 52 Зоран В. Петровић 2011-10-20 08:35:05 EDT
Created attachment 529259 [details]
FontForge Ubuntu Light Italic font with Serbian Glyphs
Comment 53 Alessandro Ceschini 2011-10-20 08:49:54 EDT
Ubuntu is a font that NATIVELY, that is as per its design, uses SPECIAL Italic glyphs, instead of just SLANTING the upright form. If you take a closer look, Liberation SANS Italic (just as most SANS fonts), is just SLANTED upright shapes, no special glyphs, be it Russian or Serbian. That is, Liberation SANS has natively no special Italic glyphs, therefore only the Serbian localized glyph to be inserted is for U+0431, namely the only one that occurs in the upright form.
I hope you now may understand what I'm trying to point out.
Comment 54 Pravin Satpute 2011-10-20 09:00:16 EDT
(In reply to comment #50)
> Ahem, before releasing my humble suggestion is that you first set up a decent
> kerning for these new glyphs. 

Yes, there is Kerning lookup, i think i should add these glyphs there as well.
Can you please put down text where you are seeing kerning problems.

reopening bug..
Comment 55 Alessandro Ceschini 2011-10-20 09:12:13 EDT
I've seen some crappy positioning in a sample text, but it's too generic. The only way is to test every possible combination. I'm going to start with the upright font, where there's only one new glyph. Going to post the results as soon as possible.
Comment 56 Alessandro Ceschini 2011-10-23 06:45:48 EDT
Hello folks, I'm sorry but I won't be of any help for this issue. I just updated to Ubuntu 11.11 and FontForge does NOT work there. No way to get it started, it just freezes after I've selected the font. If you know some other program to view/edit font features, please let me know.
Thanks.
Comment 57 Pravin Satpute 2011-10-23 23:11:29 EDT
gedit works fine with it
LANG=sr_RS.UTF-8 gedit
Comment 58 Alessandro Ceschini 2011-10-24 06:25:16 EDT
All right, nice to see gedit too supports OpenType (I didn't know that). But what I need is not a text editor (TexWorks works far better) but a FONT editor. Like FontForge, that allows me to check geometrics, kerning, other features etc...
Comment 59 Alessandro Ceschini 2011-10-24 08:53:54 EDT
Created attachment 529862 [details]
DejaVu Serif (correct) vs. Liberation Serif (wrong) glyphs

I was trying to test some combinations when I realized there seems to be some flaw in the implementation of glyphs.
Take a look at the output I got in the attached pdf.
Comment 60 Alessandro Ceschini 2011-10-24 09:10:52 EDT
Created attachment 529868 [details]
The last letter is SHA

I've also been told that there should be an OPTIONAL, not mandatory Serbian glyphs for the Italic U+0448 CYRILLIC SMALL LETTER SHA. That is, the last letter in the image I attached.
Comment 61 Зоран В. Петровић 2011-10-24 14:05:57 EDT
Created attachment 529937 [details]
Liberation Serif italic in Thundebird 7.0.1 under Windows 7 x64

Hello.
I use OpenType aware programs, Thunderbird 7.0.1 and Firefox 7.0.1 with new Liberation Serif Italic and Regular  fonts, everything is ok ( under Windows 7 x64 )
I Will attach 4 pictures, last is about small letter te, I show what is correct look, my opinion  ( I am Serbian ).
Best Regards.
Comment 62 Зоран В. Петровић 2011-10-24 14:09:28 EDT
Created attachment 529939 [details]
Liberation Serif , Firefox 7.0.1 Windows 7 x64

Hello.
This is site Serbian Orthodox Church, I forced font to Liberation Serif, everything is ok ( letter te not look like I want )
Best Regards.
Comment 63 Зоран В. Петровић 2011-10-24 14:12:03 EDT
Created attachment 529940 [details]
This is how small letter te should look

Hello.
This is how small letter te should look ( I am Serbian ).
Best Regards.
Comment 64 Alessandro Ceschini 2011-10-24 14:27:54 EDT
I understand now, you mean the underline above TE should be LONGER, covering the whole letter.
But that doesn't explain why I'm getting a point instead of Italic TE, a point instead of Normal BE, and a Greek PI instead of Italic BE.
Am I perhaps using an alpha version of the font? Maybe I downloaded the wrong version? Mine is version 1.07.1.
Comment 65 Зоран В. Петровић 2011-10-24 15:11:22 EDT
Created attachment 529946 [details]
How Ubuntu font implemented Serbian Glyphs names

This is how Ubuntu font implemented Serbian Glyphs names
Comment 66 Зоран В. Петровић 2011-10-24 15:12:01 EDT
Created attachment 529947 [details]
This is how Liberation  font implemented Serbian Glyphs names
Comment 67 Зоран В. Петровић 2011-10-24 15:12:43 EDT
Created attachment 529948 [details]
How FontForge read Ubuntu Serbian Glyphs
Comment 68 Зоран В. Петровић 2011-10-24 15:19:03 EDT
Created attachment 529950 [details]
How FontForge read Liberation  Serbian Glyphs

Hello.
I prefer Ubuntu font (FontLab,  Dalton Maag ) way how to implement glyphs names.
I do not use XeTex as You, but something is wrong with glyphs "S_BE" and "S_TE" and how program read glyphs, Thunderbird and Firefox ( HurfBuzz OpenType font rendering recognize properly these glyphs, but XeTeX not).
For me it is much better to use "original" plus locl as name for glyphs ( Ubuntu font way ).
Best Regards.
Comment 69 Зоран В. Петровић 2011-10-24 15:42:49 EDT
Created attachment 529956 [details]
How DejaVu implemented Serbian Glyphs names

Hello.
FontForge, how DejaVu implemented Serbian Glyphs names.
Serbian Glyphs (Letters) are  created in PUA range, have real unicode F6C4,F6C5, F6C6, F6C7, F6C8  positions, and than assign as glyphs to letters, with "proper name" scheme : uni0431 --> uniF6C4, Dalton Maag ( Ubuntu )  are using naming conventions based on example: afii10066 --> afii10066.locl
Maybe program do not recognize name if Glyphs name have  underline in name ?
Best Regards.
Comment 70 Alessandro Ceschini 2011-10-24 16:12:35 EDT
Thanks for you help, Зоране. This problems almost certainly stems from the glyph names. I don't know why, but maybe the underscore (_) causes some troubles to the XeLaTeX engine, but this seems to be a XeLaTeX flaw, because I tried with Pango and it does display the correct glyph with Liberation Serif.
What do you think about it? Should I fill a bug report for XeLaTeX?
Comment 71 Alessandro Ceschini 2011-10-24 16:26:30 EDT
As I can see from your pictures, this flaw affects FontForge too, it displays the same wrong glyphs as XeLaTeX. What's wrong with it? Who's to be blamed at the end?
Comment 72 Pravin Satpute 2011-10-24 23:44:32 EDT
(In reply to comment #69)
> Created attachment 529956 [details]
> How DejaVu implemented Serbian Glyphs names
> 
> Hello.
> FontForge, how DejaVu implemented Serbian Glyphs names.
> Serbian Glyphs (Letters) are  created in PUA range, have real unicode
> F6C4,F6C5, F6C6, F6C7, F6C8  positions, and than assign as glyphs to letters,
> with "proper name" scheme : uni0431 --> uniF6C4, Dalton Maag ( Ubuntu )  are
> using naming conventions based on example: afii10066 --> afii10066.locl
> Maybe program do not recognize name if Glyphs name have  underline in name ?
> Best Regards.

Does Dejavu and Ubuntu font works in XeLatex?
Its not fonts glyph name, but Open Type layout engine of rendering should support locl feature of opentype.

I tried to follow glyph names i.e S_BE (s -> for serbian and be -> glyph name) its more readable that afiii***, will follow this conventions, might be we can use as srb_be as well.

I will correct horizontal bar of TE. thanks
Comment 73 Зоран В. Петровић 2011-10-25 02:19:34 EDT
Created attachment 530006 [details]
Year 1998, How Adobe implemnted Serbian Cyrillic Glyphs

Hello.
About glyph names. I prefer Adobe way. In attached pdf file ( from 1998 ), page 9 and 18 are nice to understand, naming convention and location.
DejaVu implementation is "the same", put alternate glyphs in PUA area, the same position as Adobe did, Unicode position F6C4, F6C5, F6C6, F6C7, F6C8. Than map Glyphs, locl feature. Example: uni0442 --> uniF6C8.

All Adobe programs will work with this 100%. If XeTeX Work with Adobe  Minion or Myriad OTF Pro fonts, with DejaVu, I think that we can try this implementation.

For example , if You use program FontMatrix ( under Windows or Linux ), it is easy to find position F6C8 in PUA and view ( or edit in some font editor ). It is NOT easy to find glyphs S_BE.

Both fonts DejaVu and Liberation, implemented general Adobe Glyph List settings( from FontForge properties about fonts).

Best Regards.
Comment 74 Pravin Satpute 2011-10-25 02:31:02 EDT
Hi Зоран,
  Does Dejavu works in XeTex?
Comment 75 Зоран В. Петровић 2011-10-25 02:33:49 EDT
Created attachment 530013 [details]
DejaVu font Serbian Glyphs Unicode value
Comment 76 Зоран В. Петровић 2011-10-25 02:36:47 EDT
Created attachment 530014 [details]
Liberation Serif Serbian Glyphs Unicode values

Hello.
As You can see, difference, DejaVu put real location (F6C5) as unicode value, Liberation have -1.  
Best Regards.
Comment 77 Pravin Satpute 2011-10-25 02:40:01 EDT
Hi,

Thanks for identifying difference, If Dejavu works in XeTex i can take it as a reference and update liberation fonts.

Does Dejavu works fine in XeTex?
Comment 78 Зоран В. Петровић 2011-10-25 02:58:30 EDT
Hello.

Mister Alessandro Ceschini is XeLaTeX man. I used TeX, but long time ago, for mathematics and physics. Lot of people do not understand TeX, it is very powerful program.
Correct question for Mister Alessandro is: Does OpenType font DejaVu works in XeTeX ? As I remember, he use Adobe Minion and Myriad OpenType fonts, so generally all OpenType fonts are ready for XeTeX, right ? 

PDF file he attach is produced by xdvipdfmx 0.7.8, so this program must be checked also for compatibility. 
It is also known ( from my own experience ) that some pdf producers can not handle some fonts, for example when you convert some documents with free URW++ PS Type 1 Cyrillic fonts ( with Serbian Glyphs ), pdf file is without Serbian Glyphs. Generally glyphs are tricky ( export from LibreOffice to pdf with PS Type 1 fonts )

Best Regards.
Comment 79 Alessandro Ceschini 2011-10-25 05:00:36 EDT
To Pravin:
Adobe Minion, Garamond Pro, Myriad, DejaVu, Ubuntu, Cambria, Constantia etc... all fonts I know with Serbian glyphs DO work in XeLaTeX, LiberationSerif is the only one with quirks. But, I repeat it, strangely, pango-view does display the correct glyphs for LiberationSerif. But, as Zoran has demonstrated (FontForge doesn't work in Ubuntu 11.11, that's a known bug, I'm waiting for the fix), FontForge behaves the same way as XeLaTeX.

To Zoran:
As a matter of fact, I'm experiencing some other troubles in pdf output and above the functions "go to pdf" and "go to source file" are broken with the new version of TeXLive, maybe xdvipdfmx is to blame. Do you think I should fill a bug report about it?

Thanks
Comment 80 Pravin Satpute 2011-10-25 05:30:25 EDT
Created attachment 530040 [details]
added U+0431 in Regular like Dejavu

let me know if this works, tried same say as done in Dejavu
Comment 81 Alessandro Ceschini 2011-10-25 06:17:45 EDT
Created attachment 530045 [details]
Both glyph names do work in XeLaTeX

Good news, Mr. Satpute, if you want you can go back to the previous glyph names, I tried the new version of Sans and it still kept giving me that friggin' point instead of the expected glyph. Then I had a flash of genius and REMOVED the standard version of Liberation installed with Ubuntu... et voilà! The problem didn't stem from a faulty glyph name bur RATHER from the conflict between the beta and the mainstream version of Liberation.

In the pdf I attached both Liberation Serif (with glyph name S_BE) and Liberation Sans (with glyph name identical to DejaVu) DO work now. But if, for compatibility/consistency questions you want to conform to the DejaVu usage, just go ahead. DejaVu might not be the cutest of all fonts but it's of course a well-established reference which most free font designers conform to.

Now, three issues remain:
1) shape of Italic TE, which Zoran pointed out many times, the line above should cover the whole letter, just as in DejaVu (take a look at the pdf)
2) shape of Regular/Italic BE is identical to Greek DELTA, which is bad, it should be more like what it is in DejaVu (again, take a look at the pdf)
3) optional shape (tags hist & alt in Serbian locl GSUB) for Italic U+0448 CYRILLIC SMALL LETTER SHA, glyph shape like Italic TE, but line BENEATH, instead of above. See attachment 529868 [details] I inserted yesterday: The last letter is SHA.

Regards
Comment 82 Зоран В. Петровић 2011-10-25 06:36:32 EDT
Created attachment 530052 [details]
Unicode FC65 position belongs to Arabic Presentation Forms A

Hello.
You put glyph S_BE at location U+FC65 ( This is Arabic Presentation Forms A range ) 
DejaVu are using PUA Range, correct position is U+F6C5.
Best Regards.
Comment 83 Зоран В. Петровић 2011-10-25 06:37:14 EDT
Created attachment 530053 [details]
DejaVu PUA range for Serbian Glyphs
Comment 84 Pravin Satpute 2011-10-31 00:11:37 EDT
Thanks Alessandro for confirmation, yes i would like to go with our existing implementation.

I will resolve other mentioned issues.
Comment 85 Yuri Khan 2011-12-19 10:07:08 EST
(In reply to comment #53)

> Liberation SANS Italic (just as most SANS fonts), is just SLANTED upright
> shapes, no special glyphs, be it Russian or Serbian.

This claim is incorrect. On 1.07.0-1, the following letters appear distinctly ITALIC: U+0432 Ve, U+0433 Ghe, U+0433 De, U+0442 Te, U+0446 Tse, U+0448 Sha, U+0449 Shcha. On the other hand, these appear distinctly SLANTED: U+0438 I, U+0439 Short I, U+043F Pe. On 1.06, these were also ITALIC; they were replaced by slanted forms when the bogus bug 708330 was “fixed”.

Therefore, when 708330 is reverted, Liberation Sans Italic will be a real Italic, at least the Russian forms. It makes sense to also do the Serbian Italic shapes.
Comment 86 Alessandro Ceschini 2011-12-23 05:47:16 EST
Hi Yuri

OK, so please add Serbian localized glyphs for Liberation Sans, but still not for Liberation Mono?

Am I correct?

Greetings
Comment 87 Pravin Satpute 2011-12-23 06:10:42 EST
Remaining task is 

- Add support for serbian characters in Mono and Narrow
- Improve kerning for added new characters

Updated https://fedorahosted.org/liberation-fonts/browser/source/TODO , me too took long time to get what is remaining task in this bug ;)
Comment 88 Yuri Khan 2011-12-23 06:13:41 EST
(In reply to comment #86)

> OK, so please add Serbian localized glyphs for Liberation Sans, but still not
> for Liberation Mono?
> 
> Am I correct?

Yes. Liberation Mono Italic is in fact Slanted, so distinction of italic forms does not apply.

Of course the glyph for U+0431 Cyrillic small letter Be is different even in the upright variant and so needs to be localized too.
Comment 89 Alessandro Ceschini 2011-12-23 06:41:51 EST
Hi Pravin

As for kerning, tell me if I can help you by doing some tests, but which combinations? Or maybe you need all the possible combinations?

Answering to Yuri:

Regular & Italic glyphs for Liberation Serif & Sans

Only Regular glyphs for Liberation Mono (i.e. only U+0431 CYRILLIC SMALL LETTER BE)

Greetings
Comment 90 Pravin Satpute 2011-12-25 23:24:54 EST
Hi Alessandro,

  Few test combinations will work.

  We have added new shapes by copying/modifying existing glyphs in Mono. I saw there are already some kerning groups defined for Liberation fonts in fontforge so we just need to add these new shapes in those groups accordingly. Hoping so it will work.
Comment 91 Pravin Satpute 2012-01-31 06:55:39 EST
1) Added Serbian localized shapes in Sans, Serif and Sans Narrow.
2) Resolved kerning problem.
3) Committed in upstream repo.

Do you need these shapes in Mono as well?

upstream release is still pending from my side.
Comment 92 Fedora Update System 2012-02-09 03:44:54 EST
liberation-fonts-1.07.2-1.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/liberation-fonts-1.07.2-1.fc16
Comment 93 Fedora Update System 2012-02-09 19:55:44 EST
Package liberation-fonts-1.07.2-1.fc16:
* should fix your issue,
* was pushed to the Fedora 16 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing liberation-fonts-1.07.2-1.fc16'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-1501/liberation-fonts-1.07.2-1.fc16
then log in and leave karma (feedback).
Comment 94 Fedora Update System 2012-02-13 11:03:50 EST
liberation-fonts-1.07.2-2.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/liberation-fonts-1.07.2-2.fc16
Comment 95 Fedora Update System 2012-03-06 14:38:41 EST
liberation-fonts-1.07.2-2.fc16 has been pushed to the Fedora 16 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 96 Alessandro Ceschini 2012-03-07 11:35:47 EST
Hi Pravin, sorry I've been too busy of late, but now I'm back.

I'm happy you managed to solve the kerning problem, unfortunately, I did some tests with the new release and I found out these remarks of mine still apply:

1) shape of Italic TE, which Zoran pointed out many times, the line above
should cover the whole letter, just as in DejaVu (take a look at the pdf)
2) shape of Regular/Italic BE is identical to Greek DELTA, which is bad, it
should be more like what it is in DejaVu (again, take a look at the pdf)
3) optional shape (tags hist & alt in Serbian locl GSUB) for Italic U+0448
CYRILLIC SMALL LETTER SHA, glyph shape like Italic TE, but line BENEATH,
instead of above. See attachment 529868 [details] I inserted yesterday: The last letter
is SHA.

Regards
Comment 97 Pravin Satpute 2012-03-08 00:07:12 EST
No problem, i will come back to this.
Comment 98 Pravin Satpute 2012-12-24 03:04:28 EST
Either with Liberation 1 or Liberation 2 now only remaining thing for this bug is 

>2) shape of Regular/Italic BE is identical to Greek DELTA, which is bad, it
>should be more like what it is in DejaVu

I will work on this.
Comment 99 Fedora End Of Life 2013-04-03 16:13:39 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 100 Alessandro Ceschini 2013-04-11 12:08:56 EDT
Hi there Mr Pravin,

Sorry to bother you but I've still seen no improvement of what I reported on comment 96.

Thank you for your attention,
Comment 101 Alessandro Ceschini 2013-07-14 15:11:01 EDT
Bump! The glyphs are still buggy! Is this a closed topic? Do I need to create another bug report? Does someone bother to answer me?
Thak you!
Comment 102 Pravin Satpute 2013-07-15 01:16:32 EDT
We discussed number of issues in this bug.
Yeah. I think creating new bug with only missing part with current version will definitely help.

Can you report new bug?  
I will try to complete it in this month.
Comment 103 Alessandro Ceschini 2013-07-15 04:46:33 EDT
(In reply to Pravin Satpute from comment #102)
> We discussed number of issues in this bug.
> Yeah. I think creating new bug with only missing part with current version
> will definitely help.
> 
> Can you report new bug?  
> I will try to complete it in this month.

Hello,

Here's the new bug report: 984428

Regards,
Comment 104 Fedora Update System 2013-08-23 04:42:49 EDT
liberation-fonts-1.07.3-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/liberation-fonts-1.07.3-1.fc19
Comment 105 Fedora Update System 2013-08-23 20:02:42 EDT
Package liberation-fonts-1.07.3-1.fc19:
* should fix your issue,
* was pushed to the Fedora 19 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing liberation-fonts-1.07.3-1.fc19'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-15235/liberation-fonts-1.07.3-1.fc19
then log in and leave karma (feedback).
Comment 106 Fedora Update System 2013-08-25 18:57:11 EDT
liberation-fonts-1.07.3-1.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.